import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Player here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Player  extends Mover
{
    private int speed = 7;
    private int vSpeed = 0;
    private int acceleration = 2;
    private int jumpStrength = 17;
    private int collected = 0;
    private boolean death = false;
    private boolean endLvl = false;
    private boolean strup = false;
       
    
    /**
     * Act - do whatever the Player wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        checkKeys();
        checkFall();
        checkEnemy();
        checkmushroom();   
        checkPast();
        endLevel();
        death();          
    }
    
    /**
     * Metoda, ki preverja ali smo pritisnili tipko za premik
     */
    private void checkKeys()
    {
        if (Greenfoot.isKeyDown("left")  )
        {
            moveLeft();
        }
        
        if (Greenfoot.isKeyDown("right") )
        {
            moveRight();
        }
        if (Greenfoot.isKeyDown("up") && onGround() )
        {
            if (strup == true)
            {
            Greenfoot.playSound("hop1.wav");
        }
        else
        {
          Greenfoot.playSound("hop.wav");  
        }
            jump();
        }
    }
    
    /**
     * Metoda, ki preverja ali naj uporabi metodo fall();. Ce smo na trdih tleh (onGround), naj bo vSpeed = 0, ce pa nismo na tleh naj
     * se izvede metoda fall();.
     */
        public void checkFall()
    {
        if(onGround()) {
            vSpeed = 0;
        }
        else {
            fall();
        }
        
    }
    
        /**
     * Metoda za skok. Konstanto "jumpStrength" spremeni v negativno, kar pomeni premik proti gor po Y osi, nato pa
     * uporabi metodo "fall();", da pademo nazaj.
     */
    public void jump()
    {
        vSpeed = -jumpStrength;
        fall();
    }
    
        
    /**
     * Metoda za padec, ki simulira fiziko: pridobivamo na pospesku
     */
        public void fall()
    {
        setLocation (getX(), getY() + vSpeed );
        vSpeed = vSpeed + acceleration;
    }
    
    
        /**
     * Metoda za premik v levo
     */
    public void moveLeft()
    {
        setLocation (getX() - speed , getY() );

    }
    
    
    /**
     * Metoda za premik v desno
     */
    public void moveRight()
    {
        setLocation (getX() + speed , getY() );
    }
    
    
    
   /**
    * Metoda, ki preverja ali smo na istem polju kot nek drugi razred, ki ga vpisemo. S pomocjo te metode, lahko v drugih metodah poenostavimo
    * zapis z uporabo "canSee(imeRazreda.class)"
    */
        public boolean canSee(Class clss)
   {
        Actor actor = getOneObjectAtOffset(0, 0, clss);
        return actor != null;       
   }
    
   /**
    * S pomocjo te metode zaznamo nek razred (v tem primeru ground.class) kot neko trdo podlago skozi katero ne moremo.
    */
    public boolean onGround()
    {
        Actor under = getOneObjectAtOffset (0, getImage().getHeight() / 2, ground.class);
        return under != null;
    }
    
    
    
    /**
     * Metoda, ki preveri ali smo na istem polju kot sovrag. Ce smo, zaslisimo zvok (det.wav) in nam pristeje smrt + 1.
     */
        public void checkEnemy()
    {

        if (canSee(Enemies.class))
        {
              Greenfoot.playSound("det.wav");
              death = true;                                               

        }
          
    }
    
    /**
     * Metoda, ki preveri ali smo na istem polju kot objekt/goba. Ce smo, se klice nova metoda "eat(mushroom.class)", zaslisimo zvok
     * in nam pristeje "collected + 1"
     */
        public void checkmushroom()
    {

        if (canSee(mushroom.class)){
            eat(mushroom.class);
            if (strup == true)
            {
            Greenfoot.playSound("amam1.wav");
        }
        else
        {
           Greenfoot.playSound("amam.wav");
        }
          
            collected++;
                
            }
            if(canSee(greenMush.class)){
                eat(greenMush.class);
                Greenfoot.setSpeed(35);
                ((mushroomWorld) getWorld()).greenMush();
                strup = true;
            }
        
            if ((endLvl = true) & (collected==4))
            {
               ((mushroomWorld) getWorld()).endMat();
               strup = false;
            }

    }
    
    /**
     * Metoda, s pomocjo katere odstranimo nek objekt ko smo na istem polju.
     */     
        public void eat(Class clss)
    {
        Actor actor = getOneObjectAtOffset(0, 0, clss);
        if(actor != null) {
            getWorld().removeObject(actor);
           

        }
    }
    
    
    /**
     * Ko smo na istem polju kot razred "Past.class" klicemo metodo "checkPast();" v razredu "Wall" -> "((Wall) getWorld()).checkPast();"
     * in objekt "pojemo" oz. izbrisemo.
     */
    public void checkPast()
    {

        if (canSee(niceBear.class))
        {
            
            ((mushroomWorld) getWorld()).checkPast();
            eat(niceBear.class);
                          
        }             
      
    }
    
     

       /**
        * Pri tej metodi morata biti izpolnjena dva pogoja, da se izvede. Moramo biti na istem polju kot objekt "Konec"(dvigalo) in 
        * vrednost spremenljivke "collected" mora biti >=7. Ob vsaki pobrani gobi se nam je pristel "collected + 1", vseh 
        * gob je 7. Ce smo vse gobe pobrali, se je pogoj izpolnil..takrat zaslismo zvok, izvede se metoda ((Wall) getWorld()).end(); ,
        * zakasnitev ali Greenfoot.delay(145) in nato se izvede se ena metoda, ki nas "ponese" v nov level/stopnjo igre
        * ((Wall) getWorld()).Level();
        */
       public void endLevel()
        {
            if((canSee(exitDoor.class)) && (collected>=7))
            { 
                Greenfoot.playSound("lol.wav");
                ((mushroomWorld) getWorld()).end();
                Greenfoot.delay(145);
                ((mushroomWorld) getWorld()).Level();
                endLvl = true;
            }
    
        }
        
        /**
         * Ta metoda deluje v povezavi z metodo checkEnemy(). Tam se nam je pristel "smrt + 1", kar pomeni da smo tukaj, pri tej metodi,
         * pogoj izpolnili in se bo izvedla nova metoda ((Wall) getWorld()).gameOver();.
         * Probal sem narediti samo eno metodo, ki bi opravila vse skupaj, ampak je Greenfoot javljal neke smesne napake, zato sem
         * moral napisati dve metodi.
         */
        public void death()
        {
            if (death==true)
            {
               ((mushroomWorld) getWorld()).gameOver();
            }
        } 
}
